using System;
using System.Drawing;
using System.Collections;
using MonoTouch.Foundation;
using MonoTouch.UIKit;
using MonoTouch.ObjCRuntime;
using MonoTouch.CoreGraphics;
using Infragistics;
using System.Collections.Generic;

namespace igTest
{


	public partial class igTestViewController : UIViewController
	{
	
		
		public igTestViewController () {}
		
		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			SingleRowView srv = new SingleRowView (new RectangleF(0,0,this.View.Frame.Size.Width, this.View.Frame.Size.Height));
			srv.AutoresizingMask = UIViewAutoresizing.FlexibleHeight | UIViewAutoresizing.FlexibleWidth;
			this.View.AddSubview (srv);
			                                     
		}
		

	}

	[Register("SingleRowView")]
	public class SingleRowView : UIView
	{
		public IGGridView GridView;
		private IGGridViewImageColumnDefinition _col;
		public IGGridViewSingleRowSingleFieldDataSourceHelper Ds;

		public SingleRowView()
		{
			Initialize();
		}

		public SingleRowView(RectangleF bounds)
			: base(bounds)
		{
			Initialize();
		}

		void Initialize()
		{
			this.BackgroundColor = UIColor.Black;
			GridView = new IGGridView (new RectangleF(0f, 0f, Frame.Size.Width, 100f), IGGridViewStyle.IGGridViewStyleDefault) {
				AutoresizingMask = UIViewAutoresizing.FlexibleBottomMargin | UIViewAutoresizing.FlexibleTopMargin |
				UIViewAutoresizing.FlexibleWidth,
				SelectionType = IGGridViewSelectionType.IGGridViewSelectionTypeCell,
				HeaderHeight = 0f,
				EmptyRows = false,
				RowSeparatorHeight = 0,
				AllowHorizontalBounce = true,
				AlwaysBounceVertical = false,
				RowHeight = 100f,
				ColumnWidth = new IGColumnWidth(),
				Theme = new IGGridViewLightTheme()
			};
			this.AddSubview (GridView);

			_col = new IGGridViewImageColumnDefinition(@"Image",
			                                           IGGridViewImageColumnDefinitionPropertyType
			                                           .IGGridViewImageColumnDefinitionPropertyTypeStringUrl);

			Ds = new IGGridViewSingleRowSingleFieldDataSourceHelper(_col);
			var animls = new List<SingleRowData>
			{
				new SingleRowData("http://placepuppy.it/200/225"),
				new SingleRowData("http://placepuppy.it/200/230")
			};

			Ds.Data = animls.ToArray();

			GridView.WeakDataSource = Ds;

			
		}
	}

	[Register("SingleRowData")]
	public class SingleRowData : NSObject
	{

		public SingleRowData(string image)
		{
			Image = image;
		}

		[Export("Image")]
		public string Image { get; set; }
	}

}
